Description

We collect here some ideas on how using BOOST in CoCoALib could help improve the code.  For the moment we opt not to be

BOOST dependent; if we change our minds then we should implement the ideas listed here!

Related issues:

Related to CoCoALib - Design #932: CoCoALib configuration: BOOST dependency Closed 30 Sep 2016

History

#1 - 21 Feb 2013 16:29 - John Abbott

- Category set to Portability

(1) Specifying the unsigned integral type for small exponents -- see #268.

(2) Threadsafe counters -- see #157 (related to #156 too).

(3) bool3, 3-state booleans; BOOST offers tribool -- see #152 and #138.

#2 - 01 Apr 2014 17:35 - Anna Maria Bigatti

- Target version set to CoCoALib-0.99533 Easter14

#3 - 04 Apr 2014 17:18 - John Abbott

- Target version changed from CoCoALib-0.99533 Easter14 to CoCoALib-1.0

#4 - 30 Sep 2016 10:46 - John Abbott

- Description updated

An aspect to bear mind if we do opt to become BOOST dependent is that linking would then require linking (first) with libcocoa and (then) with the

relevant BOOST libraries.  This could be important if the idea is to produce a statically linked executable -- are there static versions of the BOOST

libraries? (e.g. on my linux "tower" computer here in Kassel there are only dynamic versions of the libraries).

Many BOOST "library parts" are really just templates in header files, so often there is no linkable code to deal with; but it is probably difficult to be sure

that all future versions of BOOST will have the same no-linkable-code parts.

#5 - 30 Sep 2016 10:56 - John Abbott

- Related to Design #932: CoCoALib configuration: BOOST dependency added

#6 - 15 Dec 2017 17:30 - John Abbott

- Status changed from New to Closed

- Assignee set to John Abbott

- Target version changed from CoCoALib-1.0 to CoCoALib-0.99560
https://cocoa.dima.unige.it/redmine/issues/268
https://cocoa.dima.unige.it/redmine/issues/157
https://cocoa.dima.unige.it/redmine/issues/156
https://cocoa.dima.unige.it/redmine/issues/152
https://cocoa.dima.unige.it/redmine/issues/138


- % Done changed from 0 to 100

I now think that it is better to avoid using BOOST if reasonably possible, since otherwise it introduces another "tedious external dependency".  Note

that CoCoA-5 dos use BOOST.

I'm hoping that new features in C++11, C++14 etc will suffice.

Closing.
